Require Import ImplemProgramWithMap.
Require Import Map_java_lang_Object.
Import P.

Module java_lang_StringType.

    Definition name : ClassName := (javaLang, 10%positive). 

End java_lang_StringType.

Module java_lang_StringSignature.
    Import java_lang_StringType.

    Definition _init_Short : ShortMethodSignature := METHODSIGNATURE.Build_t
      (13%positive)
      nil
      None
    .
    Definition _init_ : MethodSignature := (name, _init_Short).

End java_lang_StringSignature.


Module java_lang_String.


    Definition _init_Instructions :  MapN.t (Instruction*option PC) :=
      (bc_cons 0%N (Vload Aval 0%N) 1%N 
      (bc_cons 1%N (Invokespecial java_lang_ObjectSignature._init_T) 4%N 
      (bc_single 4%N (Return))))
    .

    Definition _init_Body : BytecodeMethod := BYTECODEMETHOD.Build_t
      0%N
      _init_Instructions
      nil
      1
      2
    .

    Definition _init_ : Method := METHOD.Build_t
      java_lang_StringSignature._init_Short
      (Some _init_Body)
      false
      false
      false
      Public
    .

    Definition class : Class := CLASS.Build_t
      java_lang_StringType.name
      (Some java_lang_ObjectType.name)
      nil
      mf_empty
      (ms_single _init_)
      false
      true
      false
    .

End java_lang_String.
