Require Import ImplemProgramWithMap.
Require Import Map_java_lang_Object.
Require Import Map_java_lang_Throwable.
Require Import Map_java_lang_Exception.
Import P.

Module TheProgram.

  Definition Addition_className : InterfaceName := (EmptyPackageName, 11%positive). 

  Module Addition.

    Definition className : ClassName := Addition_className.

    Definition zShortFieldSignature : ShortFieldSignature := FIELDSIGNATURE.Build_t 
      (100%positive)
      (PrimitiveType INT)
    .

    Definition zFieldSignature : FieldSignature := (className, zShortFieldSignature).

    Definition zField : Field := FIELD.Build_t
      zShortFieldSignature
      false
      true
      Package
      FIELD.UNDEF
    .

    Definition _init_ShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (10%positive)
      nil
      None
    .
    Definition _init_Signature : MethodSignature := (className, _init_ShortSignature).


    Definition addShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (11%positive)
      ((PrimitiveType INT)::nil)
      (Some (PrimitiveType INT))
    .
    Definition addSignature : MethodSignature := (className, addShortSignature).


    Definition _clinit_ShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (12%positive)
      nil
      None
    .
    Definition _clinit_Signature : MethodSignature := (className, _clinit_ShortSignature).


    Definition _init_Instructions :  MapN.t (Instruction*option PC) :=
      (bc_cons 0%N (Vload Aval 0%N) 1%N 
      (bc_cons 1%N (Invokespecial java_lang_Object._init_Signature) 4%N 
      (bc_single 4%N (Return))))
    .

    Definition _init_Body : BytecodeMethod := BYTECODEMETHOD.Build_t
      0%N
      _init_Instructions
      nil
      1
      1
    .

    Definition _init_Method : Method := METHOD.Build_t
      _init_ShortSignature
      (Some _init_Body)
      false
      false
      false
      Public
    .

    Definition addInstructions :  MapN.t (Instruction*option PC) :=
      (bc_cons 0%N (Vload Ival 0%N) 1%N 
      (bc_cons 1%N (Getstatic Addition.zFieldSignature) 4%N 
      (bc_cons 4%N (Ibinop AddInt) 5%N 
      (bc_cons 5%N (Vstore Ival 1%N) 6%N 
      (bc_cons 6%N (Vload Ival 1%N) 7%N 
      (bc_single 7%N (Vreturn Ival)))))))
    .

    Definition addBody : BytecodeMethod := BYTECODEMETHOD.Build_t
      0%N
      addInstructions
      nil
      2
      2
    .

    Definition addMethod : Method := METHOD.Build_t
      addShortSignature
      (Some addBody)
      false
      true
      false
      Public
    .

    Definition _clinit_Instructions :  MapN.t (Instruction*option PC) :=
      (bc_cons 0%N (Const BYTE 10%Z) 2%N 
      (bc_cons 2%N (Putstatic Addition.zFieldSignature) 5%N 
      (bc_single 5%N (Return))))
    .

    Definition _clinit_Body : BytecodeMethod := BYTECODEMETHOD.Build_t
      0%N
      _clinit_Instructions
      nil
      0
      1
    .

    Definition _clinit_Method : Method := METHOD.Build_t
      _clinit_ShortSignature
      (Some _clinit_Body)
      false
      true
      false
      Package
    .

    Definition class : Class := CLASS.Build_t
      className
      (Some java_lang_Object_className)
      nil
      ((mf_single zField))
      ((ms_cons _init_Method(ms_cons addMethod(ms_single _clinit_Method))))
      false
      true
      false
    .

  End Addition.

  Definition AllClasses : PROG.MapClass.t := (mc_cons Addition.class mc_empty).

  Definition AllInterfaces : PROG.MapInterface.t :=  mi_empty.

  Definition program : Program := PROG.Build_t
    AllClasses
    AllInterfaces
  .

End TheProgram.

