Require Import ImplemProgramWithMap.
Require Import Map_java_lang_Object.
Require Import Map_java_lang_Throwable.
Require Import Map_java_lang_Exception.
Import P.

Module TheProgram.

  Definition Bill_className : InterfaceName := (EmptyPackageName, 11%positive). 

  Module Bill.

    Definition className : ClassName := Bill_className.

    Definition sumShortFieldSignature : ShortFieldSignature := FIELDSIGNATURE.Build_t 
      (100%positive)
      (PrimitiveType INT)
    .

    Definition sumFieldSignature : FieldSignature := (className, sumShortFieldSignature).

    Definition sumField : Field := FIELD.Build_t
      sumShortFieldSignature
      false
      false
      Package
      FIELD.UNDEF
    .

    Definition _init_ShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (10%positive)
      nil
      None
    .
    Definition _init_Signature : MethodSignature := (className, _init_ShortSignature).


    Definition round_costShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (11%positive)
      ((PrimitiveType INT)::nil)
      (Some (PrimitiveType INT))
    .
    Definition round_costSignature : MethodSignature := (className, round_costShortSignature).


    Definition produce_billShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (12%positive)
      ((PrimitiveType INT)::nil)
      (Some (PrimitiveType BOOLEAN))
    .
    Definition produce_billSignature : MethodSignature := (className, produce_billShortSignature).


    Definition _init_Instructions :  MapN.t (Instruction*option PC) :=
      (bc_cons 0%N (Vload Aval 0%N) 1%N 
      (bc_cons 1%N (Invokespecial java_lang_Object._init_Signature) 4%N 
      (bc_single 4%N (Return))))
    .

    Definition _init_Body : BytecodeMethod := BYTECODEMETHOD.Build_t
      0%N
      _init_Instructions
      nil
      1
      1
    .

    Definition _init_Method : Method := METHOD.Build_t
      _init_ShortSignature
      (Some _init_Body)
      false
      false
      false
      Package
    .

    Definition round_costMethod : Method := METHOD.Build_t
      round_costShortSignature
      None
      false
      false
      false
      Package
    .

    Definition produce_billInstructions :  MapN.t (Instruction*option PC) :=
      (bc_cons 0%N (Const INT 1%Z) 1%N 
      (bc_cons 1%N (Vstore Ival 2%N) 2%N 
      (bc_cons 2%N (Goto 20%Z) 5%N 
      (bc_cons 5%N (Vload Aval 0%N) 6%N 
      (bc_cons 6%N (Vload Aval 0%N) 7%N 
      (bc_cons 7%N (Getfield Bill.sumFieldSignature) 10%N 
      (bc_cons 10%N (Vload Aval 0%N) 11%N 
      (bc_cons 11%N (Vload Ival 2%N) 12%N 
      (bc_cons 12%N (Invokevirtual Bill.round_costSignature) 15%N 
      (bc_cons 15%N (Ibinop AddInt) 16%N 
      (bc_cons 16%N (Putfield Bill.sumFieldSignature) 19%N 
      (bc_cons 19%N (Iinc 2%N 1%Z) 22%N 
      (bc_cons 22%N (Vload Ival 2%N) 23%N 
      (bc_cons 23%N (Vload Ival 1%N) 24%N 
      (bc_cons 24%N (If_icmp LeInt (-19)%Z) 27%N 
      (bc_cons 27%N (Const INT 1%Z) 28%N 
      (bc_cons 28%N (Vreturn Ival) 29%N 
      (bc_cons 29%N (Vstore Aval 3%N) 30%N 
      (bc_cons 30%N (Const INT 0%Z) 31%N 
      (bc_single 31%N (Vreturn Ival)))))))))))))))))))))
    .

    Definition produce_billHandlers : list ExceptionHandler := 
      (EXCEPTIONHANDLER.Build_t (Some java_lang_Exception_className) 0%N 29%N 29%N)::
      nil
    .

    Definition produce_billBody : BytecodeMethod := BYTECODEMETHOD.Build_t
      0%N
      produce_billInstructions
      produce_billHandlers
      4
      4
    .

    Definition produce_billMethod : Method := METHOD.Build_t
      produce_billShortSignature
      (Some produce_billBody)
      false
      false
      false
      Public
    .

    Definition class : Class := CLASS.Build_t
      className
      (Some java_lang_Object_className)
      nil
      ((mf_single sumField))
      ((ms_cons _init_Method(ms_cons round_costMethod(ms_single produce_billMethod))))
      false
      false
      true
    .

  End Bill.

  Definition AllClasses : PROG.MapClass.t := (mc_cons Bill.class mc_empty).

  Definition AllInterfaces : PROG.MapInterface.t :=  mi_empty.

  Definition program : Program := PROG.Build_t
    AllClasses
    AllInterfaces
  .

End TheProgram.

