Module MakeProperties (Sem:SEMANTIC_DOMAIN).
 Import Sem Prog.

 Lemma isRef_notassig_Ref : 
     forall p h v t,
       isReference v -> 
        ~ assign_compatible p h v (ReferenceType t) ->
        exists loc, v = Ref loc.
 Proof.
  intros p0 h v t H;inversion_mine H;intros HH;eauto.   
  elim HH. constructor. 
 Qed.    
 
 Lemma lookup_unique :  
      forall p exl pc e pc' pc'',
            Dom.lookup_handlers p exl pc e pc' -> 
            Dom.lookup_handlers p exl pc e pc'' ->
            pc' = pc''.
 Proof.
  induction 1;intros HH;inversion_mine HH;simpl_eq;auto.
  elim (H2 H). elim (H H6).
 Qed. 

End MakeProperties.
