Require Import ImplemProgramWithList.
Require Import List_java_lang_Object.
Require Import List_java_lang_Exception.
Import P.

Definition java_lang_RuntimeException_className : ClassName := (EmptyPackageName, RuntimeException). 

Module java_lang_RuntimeException.

    Definition className : ClassName := java_lang_Exception_className. 

    Definition _init_ShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (10%positive)
      nil
      None
    .
    Definition _init_Signature : MethodSignature := (className, _init_ShortSignature).

    Definition _init_Instructions : list (PC*Instruction) :=
      (0%N, (Vload Aval 0%N)) :: 
      (1%N, (Invokespecial java_lang_Exception._init_Signature)) :: 
      (4%N, (Return)) :: nil
    .

    Definition _init_Body : BytecodeMethod := BYTECODEMETHOD.Build_t
      _init_Instructions
      nil
      1
      1
    .

    Definition _init_Method : Method := METHOD.Build_t
      _init_ShortSignature
      (Some _init_Body)
      false
      false
      false
      Public
    .

    Definition class : Class := CLASS.Build_t
       className
      (Some java_lang_Exception.className)
      nil
      nil
      (_init_Method::nil)
      false
      true
      false.

End java_lang_RuntimeException.
