Require Import ImplemProgramWithList.
Require Import List_java_lang_Object.
Import P.

Definition java_lang_Throwable_className : ClassName := (EmptyPackageName, 11%positive). 

Module java_lang_Throwable.

    Definition className : ClassName := java_lang_Throwable_className.

    Definition _init_ShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (11%positive)
      nil
      None
    .
    Definition _init_Signature : MethodSignature := (className, _init_ShortSignature).

    Definition _init_Instructions : list (PC*Instruction) :=
      (0%N, (Vload Aval 0%N)) :: 
      (1%N, (Invokespecial java_lang_Object._init_Signature)) :: 
      (14%N, (Return)) :: nil
    .

    Definition _init_Body : BytecodeMethod := BYTECODEMETHOD.Build_t
      _init_Instructions
      nil
      1
      2
    .

    Definition _init_Method : Method := METHOD.Build_t
      _init_ShortSignature
      (Some _init_Body)
      false
      false
      false
      Public
    .

    Definition class : Class := CLASS.Build_t
      className
      (Some java_lang_Object.className)
      nil
      nil
     (_init_Method::nil)
      false
      true
      false
    .

End java_lang_Throwable.
