
Require Import ImplemProgramWithMap.
Require Import Map_java_lang_Object.
Require Import Map_java_lang_Throwable.
Require Import Map_java_lang_Exception.

Require Import ImplemWp.

Module MDom := ImplemDomain.Make P.

Require Export BigStep.
Require Export MapTypeSignatures.
Require Export BaseLogic.
Module MBigStep := BigStep.MakeBigStep MDom.

Module PCM := BinNatMapT.
Module MM := MapTypeHash MethodSign_Hash BinMapT.
Import R V5 Dom Prog.

Require Import BillMap.
Import TheProgram.

Definition bill_subclass := 
 match P.subclass_test program with
 | Some f => f
 | None => fun x y => true
 end.
